/*
Generates a finger switch. Intended for subtraction from a substrate.
*/

module fingerSwitch3D(inLen, outLen, subH) {

  flowDiam=0.75;
  fingerDiam=1.5;

  union() {

    translate([0,0])
      cylinder(subH*5,fingerDiam/2, fingerDiam/2);

    //Input port
    translate([-flowDiam/2,0])
      cube([flowDiam,inLen, subH]);

    // Output port
    mirror([0,1,0]) 
      translate([-flowDiam/2,0])
      cube([flowDiam,outLen,subH]);
  }


}

