use <balloonNozzle.scad>
use <circFromPoints.scad>
use <coandaLatch.scad>
use <fingerSwitch3D.scad>

subH=2;
subW=11;
subL=22;
subL_offset=-2.5;
floorH=1.2;
gateH=subH+0.1;
lidH=1.2;
$fn=100;

difference() {

  union() {
    // Substrate
    translate([-subW/2, -subL/2+subL_offset, -floorH])
      cube([subW,subL,subH+floorH+lidH]);

   translate([-1.5, -subL/2+subL_offset-4, -0.5])
      cube([3,4,subH+1]);
  }

  // Gate parts
  union() {

    //Coanda latch gate
    linear_extrude(gateH) coandaLatch(8);

    // Finger switches
    translate([3.25,-1]) 
      rotate([0,0,180])
      fingerSwitch3D(5,3.5,gateH);

    mirror([1,0]) 
      translate([3.25,-1]) 
      rotate([0,0,180])
      fingerSwitch3D(5,3.5,gateH);

    // Feed splitter
    translate([3.25,-5.625]) rotate([0,0,225]) translate([0,-0.75/2])
      cube([3,0.91, gateH]);


    mirror([1,0]) translate([3.25,-5.625]) rotate([0,0,225]) translate([0,-0.75/2])
      cube([3,0.91, gateH]);

    translate([0,-8,0]) cylinder(gateH, 2,2);

    // Main power feed
    translate([0,-8,0]) mirror([0,1]) translate([-1,0]) cube([2,10,gateH]);
    
  }
		
}

