from lga_experiment import Experiment
from lga_params import *
import random as random

class CoandaBistableLatch(Experiment):
    def __init__(self, *args):
        Experiment.__init__(self, *args)
        self.name = ""

    def setup(self):
        self.loadImageLGA('coanda1_640_480.png')
        self.currentStatFn = self.stat_density
        self.setup_boundaries()
        self.setup_particles()
        self.setup_src_snk()
        self.visualizer.lgaChanged()
        self.SRCVPARTICLES = WW


    def start(self):
        ENDTIME = 1000
        PRINTINTERVAL = 100
        # Define which function to use for the stats
        self.currentStatFn = self.stat_density
        self.loadBlankLGA((MAXR,MAXC))
        self.setup_particles()
        self.setup_boundaries()
        self.lga.addRegion(1, 0, 0, MAXC/2, MAXR-1) # Left half
        self.lga.addRegion(2, MAXC/2, 0, MAXC-1, MAXR-1) # Right half
        # self.setup_stats()
        self.visualizer.lgaChanged()

        print "Running until ", ENDTIME
        while self.lga.t < ENDTIME:
            self.step()
            if (self.lga.t % PRINTINTERVAL == 0):
                print self.lga.t
        myax = self.visualizer.ui_plot_stats('Single diode demon. ') # Show graph of stats

        return


    def setup_particles(self):
        # Put in a bunch of random particles in a rectangular shape
        nr, nc = self.lga.A.shape
        self.lga.RectNFill(0.04,[0,0,nr,nc]) #Fill Left side with exactly p*vol(rect) particles
        return

    # SRC:  source of particles heading EE
    # SRCA: source of particles heading ALL directions
    # SRCV: source of particles heading in a direction specified by _V_ariable SRCVPARTICLES
    # SNK: Particle sink

    def setup_src_snk(self):
        self.lga.DrawLine(238,20,242,20, SRCA);
        self.lga.DrawLine(1,20,100,20, SNK);
        self.lga.DrawLine(400,20,479,20, SNK);

        #self.lga.DrawLine(150,198,150,200,SRCA);
        self.lga.DrawLine(330,198,330,200,SRCA);
        return

    def setup_boundaries(self):
        # Set up container / boundaries / world
        nr,nc = self.lga.A.shape
        #self.lga.DrawWalls() # This makes container
        # Outer walls
        self.lga.DrawLine(0,0,0,nc-1, REV)
        self.lga.DrawLine(0,0,nr-1,0, REV)
        self.lga.DrawLine(nr-1,0,nr-1,nc, REV)
        self.lga.DrawLine(0,nc-1,nr,nc-1, REV)

        # Inner walls
        self.lga.DrawLine(1,1,1,nc-2, REV)
        self.lga.DrawLine(1,1,nr-2,1, REV)
        self.lga.DrawLine(nr-2,1,nr-2,nc-1, REV)
        self.lga.DrawLine(1,nc-2,nr-1,nc-2, REV)

        return

