from lga_experiment import Experiment
from lga_params import *
import random as random

CELLSIZE=39 # Must be ODD!
MAXR=3
MAXC=6

class MacroNAND(Experiment):
    def __init__(self, *args):
        Experiment.__init__(self, *args)
        self.name = ""

    def setup(self):
        self.currentStatFn = self.stat_density
        self.loadBlankLGA((self.cg(MAXR)+1,self.cg(MAXC)+1))
        self.setup_boundaries()
        self.setup_particles()
        self.visualizer.lgaChanged()
        self.SRCVPARTICLES = WW


    def start(self):
        ENDTIME = 1000
        PRINTINTERVAL = 10
        # Define which function to use for the stats
        self.currentStatFn = self.stat_density
        self.loadBlankLGA((self.cg(MAXR)+1,self.cg(MAXC)+1))
        self.setup_particles()
        self.setup_boundaries()

        nr, nc = self.lga.A.shape

        # Setup statistical regions
        self.lga.addRegion(4, self.cg(4), self.cg(1), self.cg(6), self.cg(2)) #Output region



        self.visualizer.lgaChanged()

        print "Running until ", ENDTIME
        while self.lga.t < ENDTIME:
            self.step()
            if (self.lga.t % PRINTINTERVAL == 0):
                print self.lga.t
        myax = self.visualizer.ui_plot_stats('Particle density map. ') # Show graph of stats

        return


    def setup_particles(self):
        # Put in a bunch of random particles in a rectangular shape
        nr, nc = self.lga.A.shape
        #Print "Setting up particles L! nr=",nr, " nc=",nc
        #rectLsml = (3,3,nr-3,nc/2-3) # shrink the square so that the particles don't overlap walls
        rectAsml = (self.cg(0)+3,self.cg(0)+3,self.cg(1)-3,self.cg(2))
        rectCsml = (self.cg(1)+3,self.cg(0)+3,self.cg(2)-3,self.cg(2))
        rectBsml = (self.cg(2)+3,self.cg(0)+3,self.cg(3)-3,self.cg(2))

#       self.lga.RectNFill(0.1,rectAsml) #Fill Left side with exactly p*vol(rect) particles
#        self.lga.RectNFill(0.1,rectCsml) #Fill Left side with exactly p*vol(rect) particles
#        self.lga.RectNFill(0.1,rectBsml) #Fill Left side with exactly p*vol(rect) particles
        return


    def setup_boundaries(self):
        # Set up container / boundaries / world
        nr,nc = self.lga.A.shape
        #self.lga.DrawWalls() # This makes container
        # Outer walls
        self.lga.DrawLine(self.cg(0),self.cg(0),self.cg(0),self.cg(MAXC), REV) #TOP
        self.lga.DrawLine(self.cg(0),self.cg(0),self.cg(MAXR),self.cg(0), REV) #LEFT
        self.lga.DrawLine(self.cg(MAXR),self.cg(0),self.cg(MAXR),self.cg(MAXC), REV) #BOTTOM
        self.lga.DrawLine(self.cg(0),self.cg(MAXC),self.cg(MAXR), self.cg(MAXC), REV) #RIGHT

        # Inner walls
        self.lga.DrawLine(self.cg(0)+1,self.cg(0),self.cg(0)+1,self.cg(MAXC), REV) #TOP
        self.lga.DrawLine(self.cg(0),self.cg(0)+1,self.cg(MAXR),self.cg(0)+1, REV) #LEFT
        self.lga.DrawLine(self.cg(MAXR)-1,self.cg(0),self.cg(MAXR)-1,self.cg(MAXC), REV) #BOTTOM
        self.lga.DrawLine(self.cg(0),self.cg(MAXC)-1,self.cg(MAXR), self.cg(MAXC)-1, REV) #RIGHT


        # LHS chamber dividers
        self.lga.DrawLine(self.cg(1), self.cg(0), self.cg(1), self.cg(2), EEEE)
        self.lga.DrawLine(self.cg(2), self.cg(0), self.cg(2), self.cg(2), EEEE)

        # Reflectors
        
        self.lga.DrawLine(self.cg(0), self.cg(3), self.cg(1), self.cg(4),NWNW)
        self.lga.DrawLine(self.cg(0), self.cg(3)+1, self.cg(1), self.cg(4)+1, NWNW)

        self.lga.DrawLine(self.cg(3), self.cg(3), self.cg(2), self.cg(4),NENE)
        self.lga.DrawLine(self.cg(3), self.cg(3)+1, self.cg(2), self.cg(4)+1, NENE)


#        self.lga.DrawLine((2*nr/3), (nc/2+(nr/3)), nr, nc/2,NENE)
#        self.lga.DrawLine((2*nr/3), (nc/2+(nr/3)+1), nr, nc/2+1,NENE)

        return


    def cg(self, index):
        return CELLSIZE*index
